searchData={"items":[{"type":"module","title":"ClusterHelper","doc":"A module helper for cluster.\nSupport work with dynamic cluster.\nBase on role and node.\nEach node can have a or many roles.\nAnd each role can have a or many nodes.","ref":"ClusterHelper.html"},{"type":"function","title":"ClusterHelper.add_role/1","doc":"Add a role for current node.","ref":"ClusterHelper.html#add_role/1"},{"type":"function","title":"ClusterHelper.add_roles/1","doc":"Add roles for current node.","ref":"ClusterHelper.html#add_roles/1"},{"type":"function","title":"ClusterHelper.all_nodes/0","doc":"Return all nodes in cluster.","ref":"ClusterHelper.html#all_nodes/0"},{"type":"function","title":"ClusterHelper.get_my_roles/0","doc":"Return roles of current node.","ref":"ClusterHelper.html#get_my_roles/0"},{"type":"function","title":"ClusterHelper.get_nodes/1","doc":"Return nodes have role.","ref":"ClusterHelper.html#get_nodes/1"},{"type":"function","title":"ClusterHelper.get_roles/1","doc":"Return roles of a node.","ref":"ClusterHelper.html#get_roles/1"},{"type":"function","title":"ClusterHelper.remove_role/1","doc":"Remove a role of current node.","ref":"ClusterHelper.html#remove_role/1"},{"type":"module","title":"ClusterHelper.NodeConfig","doc":"A module helper for node config.\nSupport work with node config.","ref":"ClusterHelper.NodeConfig.html"},{"type":"function","title":"ClusterHelper.NodeConfig.add_role/1","doc":"","ref":"ClusterHelper.NodeConfig.html#add_role/1"},{"type":"function","title":"ClusterHelper.NodeConfig.add_roles/1","doc":"","ref":"ClusterHelper.NodeConfig.html#add_roles/1"},{"type":"function","title":"ClusterHelper.NodeConfig.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ClusterHelper.NodeConfig.html#child_spec/1"},{"type":"function","title":"ClusterHelper.NodeConfig.get_all_nodes/0","doc":"","ref":"ClusterHelper.NodeConfig.html#get_all_nodes/0"},{"type":"function","title":"ClusterHelper.NodeConfig.get_my_roles/0","doc":"","ref":"ClusterHelper.NodeConfig.html#get_my_roles/0"},{"type":"function","title":"ClusterHelper.NodeConfig.get_nodes/1","doc":"","ref":"ClusterHelper.NodeConfig.html#get_nodes/1"},{"type":"function","title":"ClusterHelper.NodeConfig.get_roles/1","doc":"","ref":"ClusterHelper.NodeConfig.html#get_roles/1"},{"type":"function","title":"ClusterHelper.NodeConfig.remote_get_roles/1","doc":"","ref":"ClusterHelper.NodeConfig.html#remote_get_roles/1"},{"type":"function","title":"ClusterHelper.NodeConfig.remove_role/1","doc":"","ref":"ClusterHelper.NodeConfig.html#remove_role/1"},{"type":"function","title":"ClusterHelper.NodeConfig.remove_roles/1","doc":"","ref":"ClusterHelper.NodeConfig.html#remove_roles/1"},{"type":"function","title":"ClusterHelper.NodeConfig.start_link/1","doc":"","ref":"ClusterHelper.NodeConfig.html#start_link/1"},{"type":"extras","title":"Readme","doc":"# ClusterHelper\n\nThis lib is built on top of :syn library, help to manage dynamic Elixir cluster on environment like Kubernetes.\nEach node has roles like :data, :web, :cache other nodes join to cluster can easy get nodes follow a role in cluster.\nCan use scope for seperating to sub cluster (current version doesn't support overlapped sub cluster).","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `cluster_helper` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:cluster_helper, \"~0.0.3\"}\n  ]\nend\n```\n\nAdd `:cluster_helper` to `extra_application` in mix.exs for ClusterHelper can start with your app.\n\n```Elixir\n  def application do\n    [\n      mod: {MyApp.Application, []},\n      extra_applications: [:cluster_helper]\n    ]\n  end\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Readme","doc":"Note: You need join node to cluster by other library (like libcluster) or manually.\n\nAdd rols to config for node\n\n```Elixir\nconfig :cluster_helper,\n  # all roles of current node. Can add role in runtime.\n  roles: [:data, :web],\n  # for scope of :syn lib. default scope is ClusterHelper\n  scope: :my_cluster \n```\n\nQuery nodes by role in cluster\n\n```Elixir\nClusterHelper.get_nodes(:data)\n\n# [:node1, :node2]\n```\n\ncheck role of a node in cluster\n\n```Elixir\nClusterHelper.get_roles(:node1)\n\n# [:data, :web]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Test local cluster without integrated with other app - Readme","doc":"Start 2 nodes\n\nStart node1:\n\n```bash\niex --name node1@127.0.0.1 --cookie need_to_change_this -S mix\n```\n\n```bash\niex --name node2@127.0.0.1 --cookie need_to_change_this -S mix\n```\n\nJoin & Verify all nodes by run cmd in node2 shell:\n\n```Elixir\nNode.connect(:\"node1@127.0.0.1\")\n\nNode.list()\n```\n\nIn each iex shell add rule by cmd:\n\n```Elixir\nClusterHelper.add_roles([:role1, :role2])\n```\n\nVerify data synced by cmd:\n\n```Elixir\nClusterHelper.get_nodes(:role1)\n```","ref":"readme.html#test-local-cluster-without-integrated-with-other-app"},{"type":"extras","title":"Example - Readme","doc":"You can get a full example using with EasyRpc lib on [Github](https://github.com/ohhi-vn/lib_examples/tree/main/cluster_helper)","ref":"readme.html#example"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}